/** \file iso_base_listener.h
 *  \class iso::base::Listener abstract listener class
 *	\brief abstract listener class
 *
 *  abstract base class for any class instances that need to be informed something happens.
 *  This class simply defines a notify method...that's all...
 *
 *  Created by Daniel Bisig on 7/22/07.
 *
 */
 
 #ifndef _iso_base_listener_h_
 #define _iso_base_listener_h_
 
 namespace iso
 {
 
 namespace base
 {
 
 class Notifier;
 
 class Listener
 {
 public:
 
	/**
	\brief abstract listener method
	
	this method is called by whatever class the listener has registered itself to listen to
	*/	
	virtual void notify( ) = 0;
 
 };
 
 };
 
 };
 
 #endif

