/** \file iso_data_singleton.h
 *	\class iso::data::Singleton singleton template class
 *  \brief Singleton template class
 *
 *  Created by Daniel Bisig on 11/22/08.
 *
 */
 
 #ifndef _iso_data_singleton_h_
 #define _iso_data_singleton_h_
 
 #include "iso_data_types.h"
 #include <iostream>
 
namespace iso
{
	
namespace data
{

template <typename Type>
class Singleton
{

public:
	static Type& get();
	static void destroy();

protected:
	Singleton();
	~Singleton();
	
	static Type* sInstance;
};

template <typename Type> Type* Singleton<Type>::sInstance = NULL;

template <typename Type>
Singleton<Type>::Singleton()
{}

template <typename Type>
Singleton<Type>::~Singleton()
{}

template <typename Type>
Type&
Singleton<Type>::get()
{
	if(sInstance == NULL) sInstance = new Type();
	
	//std::cout << "singleton get " << typeid( *sInstance ).name() << "\n";
	
	return *sInstance;
}

template <typename Type>
void
Singleton<Type>::destroy()
{
	if(sInstance != NULL)
	{
		delete sInstance;
		sInstance = NULL;
	}
}

};	
	
};
 
 #endif

