/** \brief iso_data_value_function.h
 *
 *  Created by Daniel Bisig on 3/13/09.
 */

#ifndef _iso_data_value_function_h_
#define _iso_data_value_function_h_

#include "iso_data_void_value.h"

namespace iso
{

namespace data
{

#pragma mark ValueFunction (definition)

typedef void (*UnaryFunctionPtr)(VoidValue& );
typedef void (*BinaryFunctionPtr)(VoidValue&, const VoidValue& );
typedef void (*TernaryFunctionPtr)(VoidValue&, const VoidValue&, VoidValue& );

class ValueFunction
{
public:
	static const base::String sName;

	ValueFunction();
	virtual ~ValueFunction();
	
	const base::String& name() const;
	
	void apply(VoidValue& pValue) throw(base::Exception);	
	void apply(VoidValue& pValue1, const VoidValue& pValue2) throw(base::Exception);	
	void apply(VoidValue& pValue1, const VoidValue& pValue2, VoidValue& pValue3) throw(base::Exception);
	
protected:
	QHash< base::String, UnaryFunctionPtr > mUnaryFunctionMap;
	QHash< base::String, BinaryFunctionPtr > mBinaryFunctionMap;	
	QHash< base::String, TernaryFunctionPtr > mTernaryFunctionMap;				
};


};

};

#endif