/** \file iso_font_bitmap_font.h
 *
 *  Created by Daniel Bisig on 7/11/09.
 *
 */

#ifndef _iso_font_bitmap_font_h_
#define _iso_font_bitmap_font_h_

#include "iso_font.h"
#include <iso_data/iso_data_buffer.h>

#include <QVector>
#include <QHash>

namespace iso
{

namespace font
{

class BitmapFont : public Font
{
public:
	BitmapFont( const base::String& pFontName, const base::String& pFontFile, unsigned int pFontHeight ) throw (FontException);
	~BitmapFont();
	
	data::Buffer<unsigned char>* createTextBitmap( const base::String& pText, const math::Vector2<float>& pSpacing, bool pKerning ) throw (FontException);

protected:
	void createLetterBitmap( const QChar& pLetter ) throw (FontException);
	QHash<  QChar, data::Buffer<unsigned char>* > mLetterBitmaps;
};

};

};

#endif
