/** \file iso_font_vector_font.h
 *
 *  Created by Daniel Bisig on 7/11/09.
 *
 */

#ifndef _iso_font_vector_font_h_
#define _iso_font_vector_font_h_

#include "iso_font.h"
#include <iso_math/iso_math_vector2.h>
#include <iso_geom/iso_geom_spline_group.h>
#include <iso_geom/iso_geom_geometry_group.h>

#include <QHash>

namespace iso
{

namespace font
{

class VectorFont : public Font
{
public:
	VectorFont( const base::String& pFontName, const base::String& pFontFile, unsigned int pSubdivisionCount ) throw (FontException);
	~VectorFont();
	
	//geom::GeometryGroup* createTextSplines( const base::String& pText, const math::Vector2<float>& pSpacing, bool pKerning ) throw (FontException);
	geom::GeometryGroup* createTextSplines( const base::String& pText, const math::Vector2<float> pSize, const math::Vector2<float>& pSpacing, bool pKerning ) throw (FontException);
	void createTextSplines( geom::GeometryGroup* pTextSplines, const base::String& pText, const math::Vector2<float> pSize, const math::Vector2<float>& pSpacing, bool pKerning ) throw (FontException);

protected:
	static int sInternalFontSize;

	void createLetterSplines( const QChar& pLetter ) throw (FontException);

	unsigned int mSubdivisionCount; ///\brief subdivision count
	QHash< QChar, geom::SplineGroup* > mLetterSplines; ///\brief character splines
};

};

};

#endif