/** \file iso_geom_cuboid_tools.h
 *
 *  Created by Daniel Bisig on 5/18/07.
 */

#ifndef _iso_geom_cuboid_tools_h_
#define _iso_geom_cuboid_tools_h_

#include "iso_geom_cuboid.h"
#include "iso_geom_ray.h"
#include "iso_geom_line.h"

namespace iso
{

namespace geom
{

class CuboidTools
{
public:
	static CuboidTools& get();
	static void destroy();

	/**
	\brief calculcate closest point to cuboid surface
	\param pRefPoint search point
	\param pResultPoint resulting closest point
	\param pCuboid cuboid
	\remarks untested for search points inside the cuboid
	*/
	void closestPoint(const math::Vector<real>& pRefPoint, math::Vector<real>& pResultPoint, const Cuboid& pCuboid);

	/**
	\brief calculcate intersections between ray and cuboid
	\param pRay reay
	\param pCuboid cuboid
	\param pResultLine result line
	\remarks untested for search points inside the cuboid
	*/
	void intersect(const geom::Ray& pRay, const Cuboid& pCuboid, geom::Line& pResultLine);

protected:
	CuboidTools();
	~CuboidTools();

	static CuboidTools* sCuboidTools;

};

};

};

#endif