/** \file iso_geom_mesh_tools.h
 *
 *  Created by Daniel Bisig on 8/8/07.
 */

#ifndef _iso_geom_mesh_tools_h_
#define _iso_geom_mesh_tools_h_

#include <iso_base/iso_base_includes.h>
#include "iso_geom_types.h"
#include "iso_geom_poly_line.h"
#include "iso_geom_mesh.h"
#include <iso_math/iso_math_vector3.h>

namespace iso
{

namespace geom
{

class MeshTools
{
public:
	static MeshTools& get();
	static void destroy();
		
	void loadFile(const base::String& pFileName, Mesh& pMesh );
	void triangulate( const QVector< PolyLine >& pContours, Mesh& pMesh );
	
	void closestPoint(const math::Vector<real>& pRefPoint, math::Vector<real>& pResPoint, Mesh& pMesh);
	math::Vector3<real> closestPoint(const math::Vector<real>& pRefPoint, Mesh& pMesh);

protected:
	static MeshTools* sMeshTools;

	MeshTools();
	
	~MeshTools();
};

};

};

#endif