/** \file iso_space_alg_permanent_neighbors.h
 *
 *  Created by Daniel Bisig on 6/7/09.
 *
 */

#ifndef _iso_space_alg_permanent_neighbors_h_
#define _iso_space_alg_permanent_neighbors_h_

#include "iso_space_alg.h"

namespace iso
{

namespace space
{

class PermanentNeighborsAlg : public SpaceAlg
{
friend class NTreeVisitor;

public:
	PermanentNeighborsAlg(unsigned int pDim);
	PermanentNeighborsAlg(const math::Vector<real>& pMinPos, const math::Vector<real>& pMaxPos);
	~PermanentNeighborsAlg();

	void updateNeighbors( QVector< SpaceProxyObject* >& pObjects ) throw (SpaceException);
	
	/**
	\brief obtain textual ntree information
	\return String containing textual ntree information
	*/
	base::String info() const;

	/**
	\brief retrieve textual ntree information
	\param pOstream output stream
	\param pTree ntree
	*/
	friend std::ostream& operator<< (std::ostream & pOstream, const PermanentNeighborsAlg& pAlg)
	{
		pOstream << pAlg.info().toStdString(); 
		
		return pOstream;
	}

protected:
	PermanentNeighborsAlg();
};

};

};

#endif